// Learn cc.Class:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    properties: {
        camera:cc.Camera,
        frame:cc.SpriteFrame,
    },

    // LIFE-CYCLE CALLBACKS:

    onLoad () {
        this.mml = this.initMapData();
        this.gridSize = 100;
        this.background = cc.find("/Canvas/background");
        this.test = cc.find("/Canvas/test");
        this.initBigPic();
    },

    initBigPic() {
        var initPos = cc.v2(-this.gridSize * 12, -this.gridSize * 6);
        for(var i = 0; i < this.mml.length; i++) {
            var str = this.mml[i];
            for (var j = 0; j < str.length; j++) {
                var spawnPoint = cc.v2(initPos.x + j * this.gridSize, initPos.y + i * this.gridSize);
                var node = new cc.Node();
                var sprite = node.addComponent(cc.Sprite);
                sprite.spriteFrame = this.frame;
                node.width = this.gridSize;
                node.height = this.gridSize;
                node.position = spawnPoint;
                node.parent = this.background;
            }
        }
    },

    start () {
        let texture = new cc.RenderTexture();
        texture.initWithSize(this.gridSize * 24, this.gridSize * 12);
        
        this.camera.targetTexture = texture;
        this.camera.render();
        var spriteFrame = new cc.SpriteFrame();
        spriteFrame.setTexture(texture);
        var node = new cc.Node();
        node.rotation = 180;
        var sprite = node.addComponent(cc.Sprite);
        sprite.spriteFrame = spriteFrame;
        node.parent = this.test;
        this.background.removeFromParent();
    },

    initMapData() {
        return new Array(
            "000000000000000000000000",
            "000000000000000000000000",
            "000000000000000000000000",
            "000000000000000000000000",
            "000000000000000000000000",
            "000000000000000000000000",
            "000000000000000000000000",
            "000000000000000000000000",
            "000000000000000000000000",
            "000000000000000000000000",
            "000000000000000000000000",
            "000000000000000000000000",
        );
    },
});
